/*
 * main.c
 *
 *  Created on: 2023 Jan 05 10:27:02
 *  Author: user
 */




#include "DAVE.h"                 //Declarations from DAVE Code Generation (includes SFR declaration)

#include <xmc_common.h>
#include <xmc_ccu8.h>
#include <xmc_gpio.h>
#include <xmc_scu.h>
#include <xmc_hrpwm.h>

/**


 * @brief main() - Application entry point
 *
 * <b>Details of function</b><br>
 * This routine is the application entry point. It is invoked by the device startup code. It is responsible for
 * invoking the APP initialization dispatcher routine - DAVE_Init() and hosting the place-holder for user application
 * code.
 */



#define MODULE_PTR      	CCU80
#define MODULE_NUMBER   	(0U)

#define SLICE0_PTR       	CCU80_CC80
#define SLICE0_NUMBER    	(0U)
#define SLICE0_OUTPUT00		P0_5
#define SLICE0_OUTPUT01		P0_2
#define SLICE0_OUTPUT02		P0_10
#define SLICE0_OUTPUT03		P2_7

#define SLICE1_PTR       	CCU80_CC81
#define SLICE1_NUMBER    	(1U)
#define SLICE1_OUTPUT10		P0_4
#define SLICE1_OUTPUT11		P0_1
#define SLICE1_OUTPUT12		P0_9
#define SLICE1_OUTPUT13		P2_6

#define SLICE2_PTR       	CCU80_CC82
#define SLICE2_NUMBER    	(2U)
#define SLICE2_OUTPUT20		P0_3
#define SLICE2_OUTPUT21		P0_0
#define SLICE2_OUTPUT22		P2_9
#define SLICE2_OUTPUT23		P1_5

#define SLICE3_PTR       	CCU80_CC83
#define SLICE3_NUMBER    	(3U)
#define SLICE3_OUTPUT30		P0_6
#define SLICE3_OUTPUT31		P0_11
#define SLICE3_OUTPUT32		P2_8
#define SLICE3_OUTPUT33		P1_4

#define MODULE_PTR1      	CCU81
#define MODULE_NUMBER1   	(1U)

#define SLICE0_PTR1       	CCU81_CC80
//#define CCU81_SLICE0_NUMBER    	(0U)
#define CCU81_SLICE0_OUTPUT00		P1_15
#define CCU81_SLICE0_OUTPUT01		P1_12
//#define CCU81_SLICE0_OUTPUT02		P5_7
//#define CCU81_SLICE0_OUTPUT03		P2_7

#define SLICE1_PTR1       	CCU81_CC81
//#define CCU81_SLICE1_NUMBER    	(1U)
#define CCU81_SLICE1_OUTPUT10		P1_14
#define CCU81_SLICE1_OUTPUT11		P1_11
//#define CCU81_SLICE1_OUTPUT12		P5_7
//#define CCU81_SLICE0_OUTPUT03		P2_7

#define SLICE2_PTR1       	CCU81_CC82
//#define CCU81_SLICE2_NUMBER    	(2U)
#define CCU81_SLICE2_OUTPUT20		P1_13
#define CCU81_SLICE2_OUTPUT21		P1_10

#define SLICE3_PTR1       	CCU81_CC83
//#define CCU81_SLICE2_NUMBER    	(2U)
#define CCU81_SLICE3_OUTPUT30		P1_13
#define CCU81_SLICE3_OUTPUT31		P1_10

XMC_CCU8_SLICE_COMPARE_CONFIG_t SLICE_config =
{
  .timer_mode 		   = (uint32_t) XMC_CCU8_SLICE_TIMER_COUNT_MODE_EA,
  .monoshot   		   = (uint32_t) false,
  .shadow_xfer_clear   = (uint32_t) 0U,
  .dither_timer_period = (uint32_t) 0U,
  .dither_duty_cycle   = (uint32_t) 0U,

  .mcm_ch1_enable 	   = (uint32_t) false,
  .mcm_ch2_enable 	   = (uint32_t) false,

  .slice_status 	   = (uint32_t) XMC_CCU8_SLICE_STATUS_CHANNEL_2,

  .prescaler_mode	   = (uint32_t) XMC_CCU8_SLICE_PRESCALER_MODE_NORMAL,

  .passive_level_out0  = (uint32_t) XMC_CCU8_SLICE_OUTPUT_PASSIVE_LEVEL_LOW,
  .passive_level_out1  = (uint32_t) XMC_CCU8_SLICE_OUTPUT_PASSIVE_LEVEL_LOW,
  .passive_level_out2  = (uint32_t) XMC_CCU8_SLICE_OUTPUT_PASSIVE_LEVEL_LOW,
  .passive_level_out3  = (uint32_t) XMC_CCU8_SLICE_OUTPUT_PASSIVE_LEVEL_LOW,

  .asymmetric_pwm	   = (uint32_t) 0U,

  .invert_out0	   	   = (uint32_t) 0U,
  .invert_out1	   	   = (uint32_t) 1U,
  .invert_out2	   	   = (uint32_t) 0U,
  .invert_out3	   	   = (uint32_t) 1U,

  .prescaler_initval   = (uint32_t) 0U,
  .float_limit		   = (uint32_t) 0U,
  .dither_limit		   = (uint32_t) 0U,
  .timer_concatenation = (uint32_t) 0U
};

const XMC_GPIO_CONFIG_t  OUTPUT_strong_sharp_config =
{
	.mode                = XMC_GPIO_MODE_OUTPUT_PUSH_PULL_ALT3,
	.output_level        = XMC_GPIO_OUTPUT_LEVEL_LOW,
	.output_strength     = XMC_GPIO_OUTPUT_STRENGTH_STRONG_SHARP_EDGE
 };

static const XMC_CCU8_SLICE_EVENT_CONFIG_t START_config0 =
{
  .mapped_input = XMC_CCU8_SLICE_INPUT_H, // SCU.GSC80
  .edge = XMC_CCU8_SLICE_EVENT_EDGE_SENSITIVITY_RISING_EDGE, // Rising edge for start
  .level = XMC_CCU8_SLICE_EVENT_LEVEL_SENSITIVITY_ACTIVE_LOW, // Low level active for modulation
  .duration = XMC_CCU8_SLICE_EVENT_FILTER_7_CYCLES
};

static const XMC_CCU8_SLICE_EVENT_CONFIG_t START_config1 =
{
  .mapped_input = XMC_CCU8_SLICE_INPUT_M, // CCU80.ST0
  .edge = XMC_CCU8_SLICE_EVENT_EDGE_SENSITIVITY_RISING_EDGE, // Rising edge for start
  .level = XMC_CCU8_SLICE_EVENT_LEVEL_SENSITIVITY_ACTIVE_LOW, // Low level active for modulation
  .duration = XMC_CCU8_SLICE_EVENT_FILTER_7_CYCLES
};

static const XMC_CCU8_SLICE_EVENT_CONFIG_t START_config2 =
{
  .mapped_input = XMC_CCU8_SLICE_INPUT_N, // CCU80.ST1
  .edge = XMC_CCU8_SLICE_EVENT_EDGE_SENSITIVITY_RISING_EDGE, // Rising edge for start
  .level = XMC_CCU8_SLICE_EVENT_LEVEL_SENSITIVITY_ACTIVE_LOW, // Low level active for modulation
  .duration = XMC_CCU8_SLICE_EVENT_FILTER_7_CYCLES
};

static const XMC_CCU8_SLICE_EVENT_CONFIG_t START_config3 =
{
  .mapped_input = XMC_CCU8_SLICE_INPUT_O, // CCU80.ST2
  .edge = XMC_CCU8_SLICE_EVENT_EDGE_SENSITIVITY_RISING_EDGE, // Rising edge for start
  .level = XMC_CCU8_SLICE_EVENT_LEVEL_SENSITIVITY_ACTIVE_LOW, // Low level active for modulation
  .duration = XMC_CCU8_SLICE_EVENT_FILTER_7_CYCLES
};

static const XMC_CCU8_SLICE_EVENT_CONFIG_t START_config10 =
{
  .mapped_input = XMC_CCU8_SLICE_INPUT_P, // CCU81.ST3
  .edge = XMC_CCU8_SLICE_EVENT_EDGE_SENSITIVITY_RISING_EDGE, // Rising edge for start
  .level = XMC_CCU8_SLICE_EVENT_LEVEL_SENSITIVITY_ACTIVE_LOW, // Low level active for modulation
  .duration = XMC_CCU8_SLICE_EVENT_FILTER_7_CYCLES
};



XMC_HRPWM_HRC_CONFIG_t hrc0_config =
{
		  .hr_out0_inv_enable = 0,
		  .hr_out1_inv_enable = 0,
		  .hr_out0_trap_enable = (uint32_t)(XMC_HRPWM_FUNC_STATUS_DISABLE),
		  .hr_out1_trap_enable = (uint32_t)(XMC_HRPWM_FUNC_STATUS_DISABLE),
		  .hrc_shadow_xfer_linktoCCU8 = (uint32_t)(XMC_HRPWM_FUNC_STATUS_ENABLE),
		  .dt_shadow_xfer_linktoCCU8 = (uint32_t)(XMC_HRPWM_FUNC_STATUS_ENABLE),
		  .dt_enable = (uint32_t)(XMC_HRPWM_FUNC_STATUS_ENABLE),
		  .dt_trigger_sel = 0,
		  .hr_out0_passive_level_out = 0,
		  .hr_out1_passive_level_out = 0
};

XMC_HRPWM_HRC_CONFIG_t HRPWM_0_hrc_channel_config =
      {
.dt_enable                       = (uint32_t)XMC_HRPWM_FUNC_STATUS_DISABLE,
.hr_out0_trap_enable             = (uint32_t)XMC_HRPWM_FUNC_STATUS_DISABLE,
.hr_out1_trap_enable             = (uint32_t)XMC_HRPWM_FUNC_STATUS_DISABLE,
.hrc_shadow_xfer_linktoCCU8      = (uint32_t)XMC_HRPWM_FUNC_STATUS_ENABLE,
.dt_shadow_xfer_linktoCCU8       = (uint32_t)XMC_HRPWM_FUNC_STATUS_ENABLE,
.hr_out0_inv_enable              = (uint32_t)XMC_HRPWM_FUNC_STATUS_DISABLE,
.hr_out1_inv_enable              = (uint32_t)XMC_HRPWM_FUNC_STATUS_DISABLE,
.dt_trigger_sel                  = 0U,

.hr_out0_passive_level_out       = 0U,
.hr_out1_passive_level_out       = 0U,
      };

const XMC_HRPWM_HRC_SRC_CONFIG_t hrc0_source0 =
{
        .high_res_mode                   = XMC_HRPWM_HRC_HR_EDGE_SEL_BOTH,
        .set_config                      = XMC_HRPWM_HRC_SRC_INPUT_CCU,
        .clear_config                    = XMC_HRPWM_HRC_SRC_INPUT_CCU,
        .cmp_set                         = XMC_HRPWM_HRC_CMP_SEL_CSG0,
        .cmp_clear                       = XMC_HRPWM_HRC_CMP_SEL_CSG0,
        .timer_sel                       = XMC_HRPWM_HRC_TIMER_SEL_CCU_CC0,
        .set_edge_config                 = XMC_HRPWM_HRC_SRC_EDGE_SEL_RISING,
        .clear_edge_config               = XMC_HRPWM_HRC_SRC_EDGE_SEL_FALLING,
        .src_trap_enable                 = XMC_HRPWM_FUNC_STATUS_DISABLE
};

const XMC_HRPWM_HRC_SRC_CONFIG_t hrc0_source1 =
{
        .high_res_mode                   = XMC_HRPWM_HRC_HR_EDGE_SEL_BOTH,
        .set_config                      = XMC_HRPWM_HRC_SRC_INPUT_CCU,
        .clear_config                    = XMC_HRPWM_HRC_SRC_INPUT_CCU,
        .cmp_set                         = XMC_HRPWM_HRC_CMP_SEL_CSG0,
        .cmp_clear                       = XMC_HRPWM_HRC_CMP_SEL_CSG0,
        .timer_sel                       = XMC_HRPWM_HRC_TIMER_SEL_CCU_CC0,
        .set_edge_config                 = XMC_HRPWM_HRC_SRC_EDGE_SEL_DISABLED,
        .clear_edge_config               = XMC_HRPWM_HRC_SRC_EDGE_SEL_DISABLED,
        .src_trap_enable                 = XMC_HRPWM_FUNC_STATUS_DISABLE
};

const XMC_HRPWM_HRC_SRC_CONFIG_t   HRPWM_1_hrc_src_config0 =
     {
             .high_res_mode                   = XMC_HRPWM_HRC_HR_EDGE_SEL_BOTH,
             .set_config                      = XMC_HRPWM_HRC_SRC_INPUT_CCU,
             .clear_config                    = XMC_HRPWM_HRC_SRC_INPUT_CCU,
             .cmp_set                         = XMC_HRPWM_HRC_CMP_SEL_CSG0,
             .cmp_clear                       = XMC_HRPWM_HRC_CMP_SEL_CSG0,
             .timer_sel                       = XMC_HRPWM_HRC_TIMER_SEL_CCU_CC1,
             .set_edge_config                 = XMC_HRPWM_HRC_SRC_EDGE_SEL_RISING,
             .clear_edge_config               = XMC_HRPWM_HRC_SRC_EDGE_SEL_FALLING,
             .src_trap_enable                 = XMC_HRPWM_FUNC_STATUS_DISABLE
     };

const XMC_HRPWM_HRC_SRC_CONFIG_t   HRPWM_1_hrc_src_config1 =
     {
             .high_res_mode                   = XMC_HRPWM_HRC_HR_EDGE_SEL_BOTH,
             .set_config                      = XMC_HRPWM_HRC_SRC_INPUT_CCU,
             .clear_config                    = XMC_HRPWM_HRC_SRC_INPUT_CCU,
             .cmp_set                         = XMC_HRPWM_HRC_CMP_SEL_CSG0,
             .cmp_clear                       = XMC_HRPWM_HRC_CMP_SEL_CSG0,
             .timer_sel                       = XMC_HRPWM_HRC_TIMER_SEL_CCU_CC1,
             .set_edge_config                 = XMC_HRPWM_HRC_SRC_EDGE_SEL_DISABLED,
             .clear_edge_config               = XMC_HRPWM_HRC_SRC_EDGE_SEL_DISABLED,
             .src_trap_enable                 = XMC_HRPWM_FUNC_STATUS_DISABLE
     };


void GPIO_config(void)
{

	XMC_GPIO_CONFIG_t config;

	config.mode = XMC_GPIO_MODE_OUTPUT_PUSH_PULL;
	config.output_level = XMC_GPIO_OUTPUT_LEVEL_LOW;
	config.output_strength = XMC_GPIO_OUTPUT_STRENGTH_MEDIUM;

	XMC_GPIO_Init(P3_3, &config);

	//config.output_level = XMC_GPIO_OUTPUT_LEVEL_LOW;
	//XMC_GPIO_Init(LED2, &config);

}


int main(void)
{
	int i;
  DAVE_STATUS_t status;
  XMC_GPIO_CONFIG_t config;

  status = DAVE_Init();           /* Initialization of DAVE APPs  */

  if (status != DAVE_STATUS_SUCCESS)
  {
    /* Placeholder for error handler code. The while loop below can be replaced with an user error handler. */
    XMC_DEBUG("DAVE APPs initialization failed\n");

    while(1U)
    {

    }
  }


  /* Enable clock, enable prescaler block and configure global control */
  XMC_CCU8_Init(CCU80, XMC_CCU8_SLICE_MCMS_ACTION_TRANSFER_PR_CR);



  /* Start the prescaler and restore clocks to slices */
  XMC_CCU8_StartPrescaler(CCU80);

  /* Start of CCU8 configurations */
  /* Ensure fCCU reaches CCU80 */
  XMC_CCU8_SetModuleClock(CCU80, XMC_CCU8_CLOCK_SCU);

  /* Configure CCU8x_CC8y slice as timer */
  XMC_CCU8_SLICE_CompareInit(CCU80_CC80, &SLICE_config);

  /* Set period match value of the timer  */
  XMC_CCU8_SLICE_SetTimerPeriodMatch(CCU80_CC80, 1199U);

  /* Set timer compare match value for channel 1 - 50% duty */
  XMC_CCU8_SLICE_SetTimerCompareMatch(CCU80_CC80, XMC_CCU8_SLICE_COMPARE_CHANNEL_1, 599);
  /* Set timer compare match value for channel 2 - 80% duty */
  XMC_CCU8_SLICE_SetTimerCompareMatch(CCU80_CC80, XMC_CCU8_SLICE_COMPARE_CHANNEL_2, 480);

  /* Transfer value from shadow timer registers to actual timer registers */
  XMC_CCU8_EnableShadowTransfer(CCU80, XMC_CCU8_SHADOW_TRANSFER_SLICE_0);

  XMC_CCU8_SLICE_ConfigureEvent(CCU80_CC80, XMC_CCU8_SLICE_EVENT_0, &START_config0);
  XMC_CCU8_SLICE_StartConfig(CCU80_CC80, XMC_CCU8_SLICE_EVENT_0, XMC_CCU8_SLICE_START_MODE_TIMER_START_CLEAR);

  /* Configure CCU8x_CC8y slice as timer */
  XMC_CCU8_SLICE_CompareInit(CCU80_CC81, &SLICE_config);

  /* Set period match value of the timer  */
  XMC_CCU8_SLICE_SetTimerPeriodMatch(CCU80_CC81, 1199U);

  /* Set timer compare match value for channel 1 - 50% duty */
  XMC_CCU8_SLICE_SetTimerCompareMatch(CCU80_CC81, XMC_CCU8_SLICE_COMPARE_CHANNEL_1, 599);
   /* Set timer compare match value for channel 2 - 80% duty */
  XMC_CCU8_SLICE_SetTimerCompareMatch(CCU80_CC81, XMC_CCU8_SLICE_COMPARE_CHANNEL_2, 480);

  /* Transfer value from shadow timer registers to actual timer registers */
  XMC_CCU8_EnableShadowTransfer(CCU80, XMC_CCU8_SHADOW_TRANSFER_SLICE_1);



  /* Configure start event */
  /* Configure event 0 */
  XMC_CCU8_SLICE_ConfigureEvent(CCU80_CC81, XMC_CCU8_SLICE_EVENT_0, &START_config1);
  XMC_CCU8_SLICE_StartConfig(CCU80_CC81, XMC_CCU8_SLICE_EVENT_0, XMC_CCU8_SLICE_START_MODE_TIMER_START_CLEAR);

  /* Configure CCU8x_CC8y slice as timer */
  XMC_CCU8_SLICE_CompareInit(CCU80_CC82, &SLICE_config);

  /* Set period match value of the timer  */
  XMC_CCU8_SLICE_SetTimerPeriodMatch(CCU80_CC82, 1199U);

  /* Set timer compare match value for channel 1 - 50% duty */
  XMC_CCU8_SLICE_SetTimerCompareMatch(CCU80_CC82, XMC_CCU8_SLICE_COMPARE_CHANNEL_1, 599);
  /* Set timer compare match value for channel 2 - 80% duty */
  XMC_CCU8_SLICE_SetTimerCompareMatch(CCU80_CC82, XMC_CCU8_SLICE_COMPARE_CHANNEL_2, 480);
  /* Transfer value from shadow timer registers to actual timer registers */
  XMC_CCU8_EnableShadowTransfer(CCU80, XMC_CCU8_SHADOW_TRANSFER_SLICE_2);

  /* Configure start event */
  /* Configure event 0 */
  XMC_CCU8_SLICE_ConfigureEvent(CCU80_CC82, XMC_CCU8_SLICE_EVENT_0, &START_config2);
  XMC_CCU8_SLICE_StartConfig(CCU80_CC82, XMC_CCU8_SLICE_EVENT_0, XMC_CCU8_SLICE_START_MODE_TIMER_START_CLEAR);


  XMC_CCU8_EnableClock(CCU80, SLICE0_NUMBER);
  XMC_CCU8_EnableClock(CCU80, SLICE1_NUMBER);
  XMC_CCU8_EnableClock(CCU80, SLICE2_NUMBER);



  /*                                                  */
  /* Initialise the HRPWM module, start HR generation */
  /*                                                  */
  /*                                                  */
  /*                                                  */


  /* Initialise the HRPWM module, start HR generation */
  XMC_HRPWM_Init(HRPWM0);

  XMC_HRPWM_HRC_Init(HRPWM0_HRC0, &hrc0_config);   /* Initialise HRC Channel 0*/

  if (XMC_HRPWM_GetHRGenReadyStatus(HRPWM0) == XMC_HRPWM_HR_LOGIC_WORKING)
  {
	  XMC_HRPWM_EnableHighResolutionPath(HRPWM0, XMC_HRPWM_HR_PATH_HRC0);
    XMC_HRPWM_DisableLowResolutionPath(HRPWM0, XMC_HRPWM_LR_PATH_HRC0);
  }

  while (XMC_HRPWM_GetHRGenReadyStatus(HRPWM0) == XMC_HRPWM_HR_LOGIC_NOT_WORKING)
  {
    /* Wait until ready */
  }

  XMC_HRPWM_HRC_Set_HR_Source(HRPWM0_HRC0, XMC_HRPWM_HRC_SOURCE_1);  /* select Source 1 as HR path*/
  //XMC_HRPWM_HRC_ConfigSourceSelect0(HRPWM0_HRC0, &hrc0_source0);
  XMC_HRPWM_HRC_ConfigSourceSelect1(HRPWM0_HRC0, &hrc0_source0);   /* Configure Source 1*/
  XMC_HRPWM_EnableHighResolutionShadowTransfer(HRPWM0, XMC_HRPWM_HRC_SHADOW_TX_HRC0_VALUE);

#if 1
  XMC_HRPWM_HRC_Init(HRPWM0_HRC2, &HRPWM_0_hrc_channel_config);   /* Initialise HRC Channel 0*/

  if (XMC_HRPWM_GetHRGenReadyStatus(HRPWM0) == XMC_HRPWM_HR_LOGIC_WORKING)
  {
	  XMC_HRPWM_EnableHighResolutionPath(HRPWM0, XMC_HRPWM_HR_PATH_HRC0);
    XMC_HRPWM_DisableLowResolutionPath(HRPWM0, XMC_HRPWM_LR_PATH_HRC0);
  }

  while (XMC_HRPWM_GetHRGenReadyStatus(HRPWM0) == XMC_HRPWM_HR_LOGIC_NOT_WORKING)
  {
    /* Wait until ready */
  }

  XMC_HRPWM_HRC_Set_HR_Source(HRPWM0_HRC2, XMC_HRPWM_HRC_SOURCE_1);  /* select Source 1 as HR path*/
  XMC_HRPWM_HRC_ConfigSourceSelect0(HRPWM0_HRC2, &HRPWM_1_hrc_src_config0);
  XMC_HRPWM_HRC_ConfigSourceSelect1(HRPWM0_HRC2, &HRPWM_1_hrc_src_config1);   /* Configure Source 1*/
  XMC_HRPWM_EnableHighResolutionShadowTransfer(HRPWM0, XMC_HRPWM_HRC_SHADOW_TX_HRC2_VALUE);

#endif

  /* IO ports configuration for HRPWM output pins*/
  config.mode = XMC_GPIO_MODE_OUTPUT_PUSH_PULL_ALT4;
  config.output_level = XMC_GPIO_OUTPUT_LEVEL_LOW;
  config.output_strength = XMC_GPIO_OUTPUT_STRENGTH_STRONG_SHARP_EDGE;
  XMC_GPIO_Init(P0_5, &config);

  config.mode = XMC_GPIO_MODE_OUTPUT_PUSH_PULL_ALT4;
  XMC_GPIO_Init(P0_2, &config);

  XMC_GPIO_Init(P0_3, &config);
  XMC_GPIO_Init(P0_4, &config);



  /* Start */
  //XMC_SCU_SetCcuTriggerHigh(SCU_GENERAL_CCUCON_GSC80_Msk|SCU_GENERAL_CCUCON_GSC81_Msk);
  XMC_SCU_SetCcuTriggerHigh(SCU_GENERAL_CCUCON_GSC80_Msk);



  GPIO_config();

  /* Placeholder for user application code. The while loop below can be replaced with user application code. */
  while(1U)
  {
  }
}
